%{
   #include <stdio.h>
   #include <string.h>


   #define BOOLEAN_ANALIZER

   #include "boolean_analyzer.h"

   /* ----------------------------------------------------- */
   /* Error handling */
   /* ----------------------------------------------------- */

   #define MAX_ERROR 2048
   char boolean_parsing_error[MAX_ERROR];

   void boolerror (char *m)
   {
     strncpy (
               boolean_parsing_error,
               m,
               strlen(m)+1 <= MAX_ERROR ? strlen(m)+1 : MAX_ERROR-1
             );
     boolean_parsing_error[MAX_ERROR-1]=0;
   }

   /* ----------------------------------------------------- */
   /* The following code is used to interface with the in- */
   /* -memory lexical parser. */
   /* ----------------------------------------------------- */

   extern int boollex();
   int boolparse(void);
   extern void init_lexical_parser(char *src);
   extern void close_lexical_parser();

   static List *list;

   /* ----------------------------------------------------- */
   /* The boolean expression analyser itsef */
   /* ----------------------------------------------------- */

   int boolean_spliter(char *src, List *l)
   {
     int res;

     /* --------------------------------------------------- */
     /* Initialize the linked list */
     /* --------------------------------------------------- */

     list = l;

     /* --------------------------------------------------- */
     /* Parse in memory buffer pointed by 'src' */
     /* --------------------------------------------------- */

     init_lexical_parser(src);
     res = boolparse();
     close_lexical_parser();

     return res;
   }


%}

                

%union {
         char* mot;
         enum operator_name operatorval;
         enum delimitor_name delimitorval;
       }

                

%token <mot> MOT
%token <operatorval> AND
%token <operatorval> OR
%token <operatorval> XOR
%token <operatorval> NOT
%token <delimitorval> OPEN_BRAKET
%token <delimitorval> CLOSE_BRAKET

%%


expression:
    expression OR terme {
                          if (add_element (list, operator, or, NULL))
                          { return 1; }
                        }
  | terme
  ;

terme:
    terme AND facteur {
                        if (add_element (list, operator, and, NULL))
                        { return 1; }
                      }
  | terme XOR facteur {
                        if (add_element (list, operator, xor, NULL))
                        { return 1; }
                      }
  | facteur
  ;

facteur:
    OPEN_BRAKET expression CLOSE_BRAKET {}
  | NOT facteur {
                  if (add_element (list, operator, not, NULL))
                  { return 1; }
                }
  | MOT {
           if (add_element (list, word, undef, $1)) { return 1; }
         }
  ;


%%

