%{
   #include <stdlib.h>
   #include "grammar_types.h"
   #include "bool.bison.h"

   int boolwrap() { return 1; }

   /* ----------------------------------------------------- */
   /* The following code is used to parse in-memory data */
   /* -> init_lexical_parser: must be called before the */
   /* grammatical analyzer. */
   /* -> close_lexical_parser: must be called after the */
   /* end of the grammatical analyzer. */
   /* ----------------------------------------------------- */

   static YY_BUFFER_STATE buf_state;
   void init_lexical_parser(char *src) { buf_state = yy_scan_string(src); }
   void close_lexical_parser() { yy_delete_buffer(buf_state); }

   /* ----------------------------------------------------- */
   /* Allocatd memory for words */
   /* ----------------------------------------------------- */

   char *found_mot;
%}

SPACES [\t ]+
LEX_MOT [^\t\n\(\) ]+
LEX_AND "AND"
LEX_OR "OR"
LEX_XOR "XOR"
LEX_NOT "NOT"
LEX_OPEN_BRAKET \(
LEX_CLOSE_BRAKET \)

%%

{LEX_AND} {
            boollval.operatorval = and;
            return AND;
          }

{LEX_OR} {
            boollval.operatorval = or;
            return OR;
          }

{LEX_XOR} {
            boollval.operatorval = xor;
            return XOR;
          }

{LEX_NOT} {
            boollval.operatorval = not;
            return NOT;
          }

{LEX_OPEN_BRAKET} {
                    boollval.delimitorval = open_braket;
                    return OPEN_BRAKET;
                  }

{LEX_CLOSE_BRAKET} {
                     boollval.delimitorval = close_braket;
                     return CLOSE_BRAKET;
                   }

{LEX_MOT} {
            found_mot = (char*)malloc(sizeof(char) * (strlen(yytext)+1));
            if (found_mot == NULL) { return 1; }
            strcpy (found_mot, yytext);
            boollval.mot = found_mot;
            return MOT;
          }

{SPACES} { }

\n { return 0; }

%%


