/*! \file grammar_types.h
    This file defines all data types used for the BISON grammar parser.
 */

#ifndef OPRATOR_HEADER_FILE

  /*! \brief Defines the type of data used by the BISON parser to assign a
             type to all opreator tokens.
   */

  enum operator_name {
                       /*! \brief Operator <i>AND</i>. */
                       and,
                       /*! \brief Operator <i>OR</i>. */
                       or,
                       /*! \brief Operator <i>XOR</i>. */
                       xor,
                       /*! \brief Operator <i>NOT</i>. */
                       not,
                       /*! \brief This value is used to qualify a token which
                                  does not represent an operator (that is, a
                                  word). */
                       undef
                     };

  /*! \brief Defines the type of data used by the BISON parser to assign a
             type to the tockens associated with the characters <i>(</i> and
             <i>)</i>.
   */

  enum delimitor_name {
                        /*! \brief Character <i>(</i>. */
                        open_braket,
                        /*! \brief Character <i>)</i>. */
                        close_braket
                      };

#define OPRATOR_HEADER_FILE
#endif

