
#ifdef __cplusplus
extern "C" {
#endif

#ifndef LIST_H
#define LIST_H

#include <stdlib.h>

  typedef struct ListElmt_
  {

    void  *donnee;

    struct ListElmt_   *suivant;

    #ifdef DOUBLE_LINK

      struct ListElmt_   *precedent;

    #endif

  } ListElmt;

  typedef struct List_
  {

    int    taille;

    int    (*corresp)(const void *val1, const void *val2);

    void   (*detruire)(void *donnee);

    ListElmt   *tete;

    ListElmt   *queue;
  } List;

  void list_init(List *liste, void (*detruire)(void *donnee), int (*corresp)(const void *val1, const void *val2));

  void list_destroy(List *liste);

  int list_ins_next(List *liste, ListElmt *element, const void *donnee);

  int list_rem_next(List *liste, ListElmt *element, void **donnee);

  ListElmt* list_find (List *liste, ListElmt* from, void* data, ListElmt **prec);

  #define list_size(liste) ((liste)->taille)

  #define list_head(liste) ((liste)->tete)

  #define list_tail(liste) ((liste)->queue)

  #define list_is_head(liste, element)((element) == (liste)->tete ? 1 : 0)

  #define list_is_tail(element)((element)->suivant == NULL ? 1 : 0)

  #define list_data(element) ((element)->donnee)

  #define list_next(element) ((element)->suivant)

  #ifdef DOUBLE_LINK

    #define list_prev(element) ((element)->precedent)
  #endif

#endif

#ifdef __cplusplus
}
#endif
