
#include <stdlib.h>
#include <string.h>
#include "list.h"

void list_init(List *liste, void (*detruire)(void *donnee), int (*corresp)(const void *val1, const void *val2))
{
  liste->taille=0;
  liste->detruire=detruire;
  liste->corresp=corresp;
  liste->tete=NULL;
  liste->queue=NULL;

  return;
}

void list_destroy(List *liste)
{
  void  *donnee;

  while (list_size(liste) > 0)
  {
    if ((list_rem_next(liste, NULL, (void **)&donnee) == 0) && (liste->detruire !=  NULL))
    { liste->detruire(donnee); }
  }

  memset(liste, 0, sizeof(List));

  return;
}

int list_ins_next(List *liste, ListElmt *element, const void *donnee)
{
  ListElmt *nouv_element;

  if ((nouv_element=(ListElmt *)malloc(sizeof(ListElmt))) == NULL) { return -1; }

  nouv_element->donnee=(void *)donnee;

  if (element == NULL)
  {

     if (list_size(liste) == 0) { liste->queue=nouv_element; }

     nouv_element->suivant=liste->tete;

     #ifdef DOUBLE_LINK
       nouv_element->precedent=NULL;
     #endif

     liste->tete=nouv_element;
  }
  else
  {

     if (element->suivant == NULL) { liste->queue=nouv_element; }

     nouv_element->suivant=element->suivant;

     #ifdef DOUBLE_LINK
       nouv_element->precedent=element;
     #endif

     element->suivant=nouv_element;
  }

  liste->taille++;

  return 0;
}

int list_rem_next(List *liste, ListElmt *element, void **donnee)
{
  ListElmt  *ancien_element;

  if (list_size(liste) == 0) { return -1; }

  if (element == NULL)
  {

    *donnee=liste->tete->donnee;
    ancien_element=liste->tete;
    liste->tete=liste->tete->suivant;

    if (list_size(liste) == 1) { liste->queue=NULL; }

    #ifdef DOUBLE_LINK
      else { liste->tete->precedent=NULL; }
    #endif
  }
  else
  {

    if (element->suivant == NULL) { return -1; }

    *donnee=element->suivant->donnee;
    ancien_element=element->suivant;
    element->suivant=element->suivant->suivant;

    if (element->suivant == NULL) { liste->queue=element; }

    #ifdef DOUBLE_LINK
      else { element->suivant->precedent=element; }
    #endif
  }

  free(ancien_element);

  liste->taille--;

  return 0;
}

ListElmt* list_find (List *liste, ListElmt *from, void* data, ListElmt **prec)
{
  *prec=NULL; 

  if (from == NULL) { from=list_head(liste); }

  while (from != NULL)
  {
    if (liste->corresp(data, list_data(from))) { return from; }
    *prec=from;
    from=list_next(from);
  }

  return NULL;
}
